customhud.SetupItem('itspizzatime', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	local pt = p.pt_mode
	if not p.mo return end
	if not p.mo.valid return end
	local funny = v.cachePatch('PITIM'..PizzaTime.sync.hud.PizzaTimeFlash)
	local replace = executePTHook('HUD_PizzaTimeGraphic', {v,p,c})
	local x,y = 120*FRACUNIT, (200*FU - PizzaTime.sync.hud.PizzaTimeY)
	if replace
		if replace[3]
			funny = replace[3] -- THIS SHOULD BE RETURNED AS V.CACHEPATCH
		end

		if replace[1]
			x = replace[1]
		end
		if replace[2]
			y = replace[2]
		end
	end

	v.drawScaled(x,y, FRACUNIT / 4, funny, V_SNAPTOBOTTOM)
end)

customhud.SetupItem('lapnotification', 'pizzatime2.0', function(v,p,c)
	for _,obj in pairs(PizzaTime.sync.hud.Lap2Objs)
		-- v.drawString(160, -20 + obj.y, obj.name..' has reached Lap '..obj.lap, V_SNAPTOTOP, 'center')
		local str = obj.name..' has reached Lap '..obj.lap..'!'
		if obj.ohno
			str = obj.name..' has reached Extreme Lap '..obj.lap..'!'
		end
		local replace = executePTHook('HUD_LapObjString', {obj})
		if replace
			str = replace -- SHOULD BE RETURNED AS STRING
		end
		drawSuperText(v, 160, -20 + obj.y, str, {font = 'PTFNT', flags = V_SNAPTOTOP, align = 'center'})
	end
end)

customhud.SetupItem('rank', 'pizzatime2.0', function(v,p)
	if gametype ~= GT_PIZZATIME2 return end
	local pt = p.pt_mode
	if not p.mo return end
	if not p.mo.valid return end
	if PizzaTime.sync.ranks[pt.rank] then
		local rank = v.cachePatch(PizzaTime.sync.ranks[pt.rank].name..'RANK')
		v.drawScaled(26*FRACUNIT,66*FRACUNIT,FRACUNIT/3+pt.hud.rank_tween,rank,V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
	end
end)

customhud.SetupItem('pizzaface_bar', 'pizzatime2.0', function(v,p)
	if gametype ~= GT_PIZZATIME2 return end
	local pt = p.pt_mode
	if not p.mo return end
	if not p.mo.valid return end
	if PizzaTime.sync.PizzaTime
	and not PizzaTime.sync.ExtremeLap
	and ((PizzaTime.sync.SpecialPlayers.PizzaFaces[1]
	and PizzaTime.sync.SpecialPlayers.PizzaFaces[1].valid)
	or (PizzaTime.sync.Pizzaface_AI.mobj
	and PizzaTime.sync.Pizzaface_AI.mobj.valid))
		local pizzafacetime = 0
		if not PizzaTime.sync.Practice then
			pizzafacetime = PizzaTime.sync.SpecialPlayers.PizzaFaces[1].pt_mode.pizzaface_stun
		else
			pizzafacetime = PizzaTime.sync.Pizzaface_AI.pizzaface_stun
		end

		local min = G_TicsToMinutes(pizzafacetime, true)
		local sec = G_TicsToSeconds(pizzafacetime)
		local cen = G_TicsToCentiseconds(pizzafacetime)
		local minp, secp, cenp = '', '', ''
		
		//padding
		if (sec < 10) then secp = '0' end
		if (cen < 10) then cenp = '0' end
		
		local maxtime = 26*((30*TICRATE)*FU/9)/25
		local curtime = 26*(pizzafacetime*FU/9)/25
		if PizzaTime.sync.LaughedLol then
			curtime = 26*(0*FU/9)/25
		end
		local mipatch = v.cachePatch("PIZZAFILL")
		
		v.drawStretched(98*FU,(182+120-PizzaTime.sync.hud.PizzaTimeTimerY)*FRACUNIT,maxtime-curtime,FU*2, mipatch,V_SNAPTOBOTTOM)

		v.drawScaled(150*FRACUNIT,(180+120-PizzaTime.sync.hud.PizzaTimeTimerY)*FRACUNIT,2*FRACUNIT/5,v.cachePatch("PIZZABAR"), V_SNAPTOBOTTOM)
		if animation_handler.john_timer
			v.drawScaled(89*FRACUNIT+(maxtime-curtime),(182+120-PizzaTime.sync.hud.PizzaTimeTimerY)*FRACUNIT,2*FRACUNIT/5,v.cachePatch(animation_handler.john_timer.anim..animation_handler.john_timer.curframe),V_SNAPTOBOTTOM)
		end
		if animation_handler.pizzaface_showtime
			v.drawScaled(200*FRACUNIT,(178+120-PizzaTime.sync.hud.PizzaTimeTimerY)*FRACUNIT,2*FRACUNIT/6,v.cachePatch(animation_handler.pizzaface_showtime.anim..animation_handler.pizzaface_showtime.curframe),V_SNAPTOBOTTOM)
		elseif animation_handler.pizzaface_isleep
			v.drawScaled(210*FRACUNIT,(168+120-PizzaTime.sync.hud.PizzaTimeTimerY)*FRACUNIT,2*FRACUNIT/6,v.cachePatch(animation_handler.pizzaface_isleep.anim..animation_handler.pizzaface_isleep.curframe),V_SNAPTOBOTTOM)
		end
		local str = minp..min..":"..secp..sec
		if PizzaTime.sync.LaughedLol
			str = 'SHOWTIME!'
		end
		-- v.drawString(160,183+120-PizzaTime.sync.hud.PizzaTimeTimerY,str,0,"center",V_SNAPTOBOTTOM)
		drawSuperText(v, 160, 184+120-PizzaTime.sync.hud.PizzaTimeTimerY,str,{font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
	end
end)

customhud.SetupItem('titlecard', 'pizzatime2.0', function(v)
	if gametype ~= GT_PIZZATIME2 return end
	local w = v.width()
	local h = v.height()
	local scalex,fixedscalex = v.dupx()
	local scaley,fixedscaley = v.dupy()
	local scale = {x = FixedDiv(w*FU, fixedscalex), y = FixedDiv(h*FU, fixedscaley)}
	if PizzaTime.sync.TitleCardName then
		local name = PizzaTime.sync.TitleCardName[1]
		local titlecard = v.cachePatch(name..'TC')
		if titlecard then
			local bg = v.cachePatch('BLACKG')
			if PizzaTime.sync.TitleCard.alpha2 < 10 then
				local flag = V_SNAPTOTOP|V_SNAPTOLEFT
				if PizzaTime.sync.TitleCard.alpha2 > 1
					flag = $|PizzaTime.sync.TitleCard.alpha2<<V_ALPHASHIFT
				end
				v.drawStretched(0,0,v.width()*FU,v.height()*FU,bg,flag)
			end
			if PizzaTime.sync.TitleCard.alpha < 10 then
				local flag = nil
				if PizzaTime.sync.TitleCard.alpha > 1
					flag = PizzaTime.sync.TitleCard.alpha<<V_ALPHASHIFT
				end
				v.drawScaled(0,0,FRACUNIT/2,titlecard,flag)
			end
		end
	end
end, 'gameandscores')

customhud.SetupItem('nametags', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	if not PizzaTime.sync.PizzaTime return end
	local pt = p.pt_mode
	if not p.mo return end
	if not p.mo.valid return end
	if pt.pizzaface
		for player in players.iterate
			if player == p then continue end
			if player.valid and player.mo and player.mo.valid and not player.pt_mode.pizzaface
				local pV = R_WorldToScreen2(p, c, player.mo,v)
				if pV.onscreen
					drawSuperText(v, pV.x, pV.y,player.name,{font = 'PTFNT', align = 'center', fixed = true, flags = V_PERPLAYER|V_TRANSLUCENT})
					-- v.drawString(pV.x, pV.y, p2.name, V_80TRANS, 'fixed-center')
				end
			end
		end
	else
		for player in players.iterate
			if player.valid and player.mo and player.mo.valid and player.pt_mode.pizzaface
				local pV = R_WorldToScreen2(p, c, player.mo,v)
				if pV.onscreen
					drawSuperText(v, pV.x, pV.y,player.name,{font = 'PTFNT', align = 'center', fixed = true, flags = V_PERPLAYER|V_TRANSLUCENT})
				end
			end
		end
		if PizzaTime.sync.PizzaTimeSign
			local pV = R_WorldToScreen2(p, c, PizzaTime.sync.PizzaTimeSign,v)
			if pV.onscreen
				drawSuperText(v, pV.x, pV.y,'GOAL!',{font = 'PTFNT', align = 'center', fixed = true, flags = V_PERPLAYER, color = SKINCOLOR_YELLOW})
			end
		end
	end
end)

customhud.SetupItem('lapscounter', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	if not PizzaTime.sync.PizzaTime return end
	if not p.mo return end
	if not p.mo.valid return end
	local pt = p.pt_mode
	v.drawString(40, 10 + (16 * 3), "\x82\LAPS: "..pt.lap, V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
end)

customhud.SetupItem('canstartlap', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	if not p.mo return end
	if not p.mo.valid return end
	if p.exiting
		if PizzaTime.functions.checks.CanLap(p) and not PizzaTime.sync.LapPortalExists
			-- v.drawString(160, 170, 'Hey! You can keep going! Press Fire!', V_60TRANS|V_ALLOWLOWERCASE|V_SNAPTOBOTTOM, 'center')
			drawSuperText(v, 160*FRACUNIT, 170*FRACUNIT,'You can start a new lap by pressing Fire',{font = 'PTFNT', align = 'center', fixed = true, flags = V_PERPLAYER|V_SNAPTOBOTTOM})
		end
	end
end)

customhud.SetupItem('pizzaface_waittime', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	local pt = p.pt_mode
	if not p.mo return end
	if not p.mo.valid return end
	if pt.pizzaface and pt.pizzaface_stun > 0
		local str = "Since you are Pizzaface you have to wait for "..p.pt_mode.pizzaface_stun/TICRATE..' seconds'
		local replace = executePTHook('HUD_PizzafaceWaitDraw', {p})
		if replace
			str = replace -- STRING
		end
		drawSuperText(v, 160, 20, str, {font = 'PTFNT', flags = V_30TRANS|V_SNAPTOTOP, align = 'center', scale = FRACUNIT - (FRACUNIT / 16)})
		-- v.drawString(160, 20, "Since you're Pizzaface, you have to wait for "..pt.pizzaface_stun/TICRATE..' seconds!', V_30TRANS|V_ALLOWLOWERCASE|V_SNAPTOTOP, 'thin-center')
	end
end)

customhud.SetupItem('wartimer', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	local pt = p.pt_mode
	if not p.mo return end
	if not p.mo.valid return end
	if pt.war_timer.activated
		local min = G_TicsToMinutes(pt.war_timer.time, true)
		local sec = G_TicsToSeconds(pt.war_timer.time)
		local minp, secp = '', ''
		
		//padding
		if (sec < 10) then secp = '0' end
		if (min < 10) then minp = '0' end
		local x,y = 63*FRACUNIT,145*FRACUNIT
		local patch = v.cachePatch('WARALAR1')
		local funny = executePTHook('HUD_WarTimerBackDraw', {v,p,c})
		if funny
			if funny[3]
				patch = funny[3] -- RETURN AS V.cachePatch
			end
			if funny[1]
				x = funny[1]
			end
			if funny[2]
				y = funny[2]
			end
		end
		v.drawScaled(x,y,FRACUNIT/2,patch,V_SNAPTOBOTTOM)
		drawSuperText(v, 63+56, 145+19,minp..min..' '..secp..sec,{font = 'WARFN', flags = V_SNAPTOBOTTOM, align = 'left', scale = FRACUNIT/2, color = SKINCOLOR_RED})
	end
end)

customhud.SetupItem('defendernotification', 'pizzatime2.0', function(v,p,c)
	if gametype ~= GT_PIZZATIME2 return end
	if not p.mo return end
	if not p.mo.valid return end
	local pt = p.pt_mode
	if pt.defender then
		drawSuperText(v, 160, 160, 'You are a defender', {font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
		drawSuperText(v, 170, 170, 'Press fire to use your shotgun against Pizzaface', {font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
	end
end)

customhud.SetupItem('extremelapoverlay', 'pizzatime2.0', PizzaTime.functions.tools.ExtremeLapOverlayDrawer, 'gameandscores')