addHook('NetVars', function(n)
	PizzaTime.sync = n($)
end)

addHook('MapChange', function(map)
	PizzaTime.sync.Defined = false
	PizzaTime.functions.inits.MapInit(map)
end)

addHook('MapLoad', function()
	PizzaTime.functions.inits.MapFinishInit()
end)

addHook('MobjLineCollide', function(mo,line)
	if gametype ~= GT_PIZZATIME2 then return end
	if not PizzaTime.sync.Defined then return end
	PizzaTime.functions.checks.PlayerSpotCheck(mo,line)
end, MT_PLAYER)

addHook('PlayerSpawn', function(p)
	if gametype ~= GT_PIZZATIME2 then return end
	if not PizzaTime.sync.Defined then return end
	if p.mo and p.mo.valid then
		PizzaTime.functions.hooks.PlayerSpawnFunc(p)
	end
end)

addHook('MapThingSpawn', function(mo,t)
	if gametype ~= GT_PIZZATIME2 then return end
	if not executePTHook('RemoveItem', {mo,t}) and (t.type == 409 or t.type == 404)
		P_RemoveMobj(mo)
		return true
	end
end)

addHook('PlayerThink', function(p)
	if gametype ~= GT_PIZZATIME2 then return end
	if not PizzaTime.sync.Defined then return end
	if not p.pt_mode then PizzaTime.functions.inits.PlayerInit(p) end
	PizzaTime.functions.hooks.PlayerThinker(p)
	PizzaTime.functions.hooks.PizzafaceThinker(p)
	PizzaTime.functions.hooks.PlayerShotgunThinker(p)
	PizzaTime.functions.hooks.WarThinker(p)
	PizzaTime.functions.hooks.ExitedPlayerThinker(p)
end)


addHook('MobjCollide', function(mo, mo2)
	if not PizzaTime.sync.Defined then return end
	if not L_ZCollide(mo,mo2) then return end
	if not mo.player.pt_mode then return end
	if not mo.player.pt_mode.pizzaface then return end
	PizzaTime.functions.hooks.PizzafaceKill(mo,mo2)
end, MT_PLAYER)

addHook('MusicChange', PizzaTime.functions.hooks.PizzaTimeMusicThinker)

addHook('ThinkFrame', function()
	if gametype ~= GT_PIZZATIME2 then return end
	if not PizzaTime.sync.Defined then return end
	PizzaTime.functions.hooks.GlobalThinker()
	PizzaTime.functions.hooks.HUDThinker()
end)

addHook('IntermissionThinker', function()
	if gametype ~= GT_PIZZATIME2 then return end
	PizzaTime.functions.hooks.IntermissionThinker()
end)

addHook('MobjDeath', PizzaTime.functions.tools.CollectRings, MT_RING)
addHook('MobjDeath', PizzaTime.functions.tools.KillRingBox, MT_RING_BOX)

addHook('TouchSpecial', PizzaTime.functions.hooks.JohnCollideThinker, MT_PILLARJOHN)
addHook('MobjSpawn', PizzaTime.functions.hooks.JohnSpawn, MT_PILLARJOHN)
addHook('MobjThinker', PizzaTime.functions.hooks.JohnThinker, MT_PILLARJOHN)
addHook('MobjDeath', PizzaTime.functions.hooks.JohnDeath, MT_PILLARJOHN)

addHook('TouchSpecial', PizzaTime.functions.hooks.LapPortalCollideThinker, MT_LAPPORTAL)

addHook('MobjDeath', PizzaTime.functions.hooks.MonitorDeath)